<?php

defined('_JEXEC') or die();

class GetMailingControllergetmailing extends GetMailingController {

    /**
     * constructor (registre tasks adicionais para as functions)
     * @return void
     */
    function __construct() {

        parent::__construct();

        //Registrando as tasks extras...

        $this->registerTask('add', 'edit');

        $this->registerTask('apply', 'save');

        $this->registerTask('texto_introducao', 'textoIntroducao');

        $this->registerTask('salva_texto_introducao', 'salvaTextoIntroducao');

        $this->registerTask('importar_exportar', 'importarExportar');
        $this->registerTask('exportar_mailing_txt', 'exportarMailingTxt');
        $this->registerTask('exportar_mailing_excel', 'exportarMailingExcel');
        $this->registerTask('exportar_backup', 'exportarBackup');

        $this->registerTask('importar_mailing_txt', 'importarMailingTxt');
        $this->registerTask('restaurar_backup', 'restaurarBackup');

        $this->registerTask('texto_email_confirmacao', 'textoEmailConfirmacao');
        $this->registerTask('salva_texto_email_confirmacao', 'salvaTextoEmailConfirmacao');

        $this->registerTask('texto_email_sucesso', 'textoEmailSucesso');
        $this->registerTask('salva_texto_email_sucesso', 'salvaTextoEmailSucesso');

        $this->registerTask('sobre_getmailing', 'sobreGetMailing');        

    }
   

    /**
     * Requisia o formulário de edição ou inserção de registro
     * @return void
     */
    function edit() {

        JRequest::setVar('view', 'registro');

        JRequest::setVar('layout', 'form');

        parent::display();

    }

    /**
     * Salva o registro e redireciona para a listagem de registros
     * @return void
     */
    function save() {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel('registro');


        if ($model->store()) {

            $msg = JText::_('SALVAR_REGISTRO_OK');

        } else {

            $msg = JText::_('ERRO_SALVAR_REGISTRO');

        }

        $link = 'index.php?option=com_getmailing';

        $this->setRedirect($link, $msg);

    }

    /**
     * Deleta os registros selecionados
     * @return void
     */
    function remove() {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel('registro');

        if(!$model->delete()) {

            $msg = JText::_( 'NENHUM_REGISTRO_SELECIONADO' );

        } else {

            $msg = JText::_( 'EXCLUIR_REGISTRO_OK' );

        }

        $this->setRedirect( 'index.php?option=com_getmailing', $msg );

    }

    /**
     * Publica os registros selecionados
     * @return void
     */
    function publish() {

        JRequest::checkToken() or jexit('Invalid Token');

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );

        JArrayHelper::toInteger($cid);

        if (count( $cid ) < 1) {

            JError::raiseError(500, JText::_( 'NENHUM_REGISTRO_SELECIONADO' ) );

        }

        $model = $this->getModel('registro');

        if(!$model->publish($cid, 1)) {

            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";

        }

        $this->setRedirect( 'index.php?option=com_getmailing' );

    }

    /**
     * Despublica os registros selecionados
     * @return void
     */
    function unpublish() {

        JRequest::checkToken() or jexit('Invalid Token');

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );

        JArrayHelper::toInteger($cid);

        if (count( $cid ) < 1) {

            JError::raiseError(500, JText::_( 'NENHUM_REGISTRO_SELECIONADO' ) );

        }

        $model = $this->getModel('registro');

        if(!$model->publish($cid, 0)) {

            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";

        }

        $this->setRedirect( 'index.php?option=com_getmailing' );

    }

    /**
     * Cancela a edição ou inserção do registro
     * @return void
     */
    function cancel() {

        JRequest::checkToken() or jexit('Invalid Token');

        $this->setRedirect( 'index.php?option=com_getmailing');

    }

    /**
     * Requisite o formulário de introdução
     * @return void
     */

    function textoIntroducao() {

        JRequest::setVar('view', 'introducao');

        JRequest::setVar('layout', 'default');

        parent::display();

    }

    /**
     * Requisita o formulário de Confirmação
     * @return void
     */
    function textoEmailConfirmacao() {

        JRequest::setVar('view', 'emailconfirmacao');

        JRequest::setVar('layout', 'default');

        parent::display();

    }

    /**
     * Requisita o formulário de Sucesso
     * @return void
     */
    function textoEmailSucesso() {

        JRequest::setVar('view', 'emailsucesso');

        JRequest::setVar('layout', 'default');

        parent::display();

    }

    /**
     * Requisita a tela de exportar o Mailing
     * @return void
     */
    function importarExportar() {

        $this->esvaziaDiretorio();
        
        JRequest::setVar('view', 'exportar');

        JRequest::setVar('layout', 'default');

        parent::display();

    }

    /**
     * Requisite a tela com a documentação do GetMailing
     * @return void
     */
    function sobreGetMailing() {

        JRequest::setVar('view', 'sobre');

        JRequest::setVar('layout', 'default');

        parent::display();

    }

    /**
     * Esvazia o diretório media/getmailing, responsável por armazenar todos os arquivos manipulados pelo componente
     * Faz isso para, de acordo com o tempo, não gerar uma qtde muito grande de arquivos que serão usados apenas uma vez
     * @return boolean
     */
    function esvaziaDiretorio(){

        $folder	= 'media' . DS . 'getmailing' . DS ;
        $dirRoot = JPATH_ROOT . DS .  $folder;

        $files = JFolder::files($dirRoot, '.', false, true, array());

        if (!empty($files)) {

            jimport('joomla.filesystem.file');
            if (JFile::delete($files) !== true) {

                return false;

            }

        }
    }

    /**
     * Salva o texto da introdução
     * @return void
     */
    function salvaTextoIntroducao() {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel('introducao');

        if ($model->salvaIntroducao()) {

            $msg = JText::_('SALVAR_INTRODUCAO_OK');

        } else {

            $msg = JText::_('ERRO_SALVAR_INTRODUCAO');

        }

        $link = 'index.php?option=com_getmailing&task=texto_introducao&controller=getmailing';

        $this->setRedirect($link, $msg);

    }

    /**
     * Salva o texto do email de confirmação
     * @return void
     */
    function salvaTextoEmailConfirmacao() {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel('emailconfirmacao');

        if ($model->salvaEmailConfirmacao()) {

            $msg = JText::_('SALVAR_TEXTO_CONFIRMACAO_OK');

        } else {

            $msg = JText::_('ERRO_SALVAR_TEXTO_CONFIRMACAO');

        }

        $link = 'index.php?option=com_getmailing&task=texto_email_confirmacao&controller=getmailing';

        $this->setRedirect($link, $msg);

    }

    /**
     * Salva o texto do email de sucesso
     * @return void
     */
    function salvaTextoEmailSucesso() {

        JRequest::checkToken() or jexit('Invalid Token');

        $model = $this->getModel('emailsucesso');

        if ($model->salvaEmailSucesso()) {

            $msg = JText::_('SALVAR_TEXTO_SUCESSO_OK');

        } else {

            $msg = JText::_('ERRO_SALVAR_TEXTO_SUCESSO');

        }

        $link = 'index.php?option=com_getmailing&task=texto_email_sucesso&controller=getmailing';

        $this->setRedirect($link, $msg);

    }

    /**
     * Exporta o mailing para um arquivo de texto (.txt)
     * @return void
     */
    function exportarMailingTxt() {

        $model = $this->getModel('exportar');

        try {

            $model->exportarMailingTxt();

        }

        catch(Exception $erro) {

            $msg = JText::_('ERRO_EXPORTAR_MAILING_TXT');

            $link = 'index.php?option=com_getmailing&task=importar_exportar&controller=getmailing';

            $this->setRedirect($link, $msg);

        }

    }

    /**
     * Exporta o mailing para um arquivo do excel (.xls)
     * @return void
     */
    function exportarMailingExcel() {

        $model = $this->getModel('exportar');


        try {

            $model->exportarMailingExcel();

        }

        catch(Exception $erro) {

            $msg = JText::_('ERRO_EXPORTAR_MAILING_EXCEL');

            $link = 'index.php?option=com_getmailing&task=importar_exportar&controller=getmailing';

            $this->setRedirect($link, $msg);

        }

    }

    /**
     * Importa mailing de um arquivo texto (como o que é gerado pelo GetMailing)
     * @return void
     */
    function importarMailingTxt() {

        $model = $this->getModel('exportar');

        if ($model->importarMailingTxt()) {

            $msg = JText::_('IMPORTAR_MAILING_SUCESSO');

        } else {

            $msg = JText::_('IMPORTAR_MAILING_ERRO');

        }

        $link = 'index.php?option=com_getmailing&task=importar_exportar&controller=getmailing';

        $this->setRedirect($link, $msg);

    }


    function exportarBackup(){

        $model = $this->getModel('exportar');

        if ($model->exportarBackup()) {

            $msg = JText::_('EXPORTAR_BACKUP_SUCESSO');

        } else {

            $msg = JText::_('EXPORTAR_BACKUP_ERRO');

        }

        $link = 'index.php?option=com_getmailing&task=importar_exportar&controller=getmailing';

        $this->setRedirect($link, $msg);

    }

    function restaurarBackup(){

        $model = $this->getModel('exportar');

        if ($model->restaurarBackup()) {

                $msg = JText::_('RESTAURAR_BACKUP_SUCESSO');

        } else {

            $msg = JText::_('RESTAURAR_BACKUP_ERRO');

        }

        $link = 'index.php?option=com_getmailing&task=importar_exportar&controller=getmailing';

        $this->setRedirect($link, $msg);

    }


} //Class GetMailingControllergetmailing

?>