<?php

defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class GetMailingModelRegistro extends JModel {

    /**
     * Constructor that retrieves the ID from the request
     * @access	public
     * @return	void
     */
    function __construct() {

        parent::__construct();
       
        $array = JRequest::getVar('cid',  0, '', 'array');

        $this->setId((int)$array[0]);

    }

    /**
     * Método que seta o identificador do registro
     * @access	public
     * @param	int identifier
     * @return	void
     */
    function setId($id) {

        // Define o ID e apaga os dados

        $this->_id = $id;
        $this->_data = null;

    }

    /**
     * Captura os dados do registro
     * @return objeto com os dados
     */
    function &getRegistro() {

        if (empty( $this->_data )) {

            $query = ' SELECT * FROM #__getmailing WHERE id = ' . $this->_id;

            $this->_db->setQuery( $query );

            $this->_data = $this->_db->loadObject();

        }

        if (!$this->_data) {

            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->frase = null;
            $this->_data->autor = null;
            $this->_data->published = 0;

        }

        return $this->_data;

    }

    /**
     * Method to store a record
     * @access	public
     * @return	boolean	True on success
     */
    function store() {

        $row =& JTable::getInstance('getmailing', 'Table');

        $retorno = true;

        $id =  JRequest::getVar('id', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $nome =  JRequest::getVar('nome', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $email = JRequest::getVar('email', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $published = JRequest::getVar('published', '', 'post', 'string', JREQUEST_ALLOWRAW);

        if($published == '0' || $published == 0)
            $published = '0';

        else
            $published = '1';


        if($id == null || $id == 0) {

            $row->data_cadastro = date('Y-m-d H:i:s');

        }

        $row->id = (int) $id;
        $row->nome = $nome;
        $row->email = $email;
        $row->uid = md5(time());
        $row->published = $published;

        // Verifica a consistencia dos campos da tabela getmailing
        if (!$row->bind(JRequest::get('post'))) {

            $this->setError($this->_db->getErrorMsg());

            $retorno = false;

        }

        // Verifica se os dados são válidos
        if (!$row->check()) {

            $this->setError($this->_db->getErrorMsg());

            $retorno = false;

        }

        // Insere ou atualiza os dados na tabela getmailing
        if (!$row->store()) {

            $this->setError( $row->getErrorMsg() );

            $retorno = false;

        }

        return $retorno;

    }



    /**
     * Método que deleta os registros selecionados
     * @access	public
     * @return	boolean	True em caso de sucesso
     */
    function delete() {

        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

        $row =& JTable::getInstance('getmailing', 'Table');

        if (count( $cids )) {

            foreach($cids as $cid) {

                if (!$row->delete( $cid )) {

                    $this->setError( $row->getErrorMsg() );

                    return false;

                }

            }

        }

        return true;

    }



    /**

     * Método que publica ou despublica os registros
     *
     * @access	public
     * @return	boolean	True em caso de sucesso
     */
    function publish($cid = array(), $publish = 1) {

        if(count($cid)) {

            JArrayHelper::toInteger($cid);

            $listaIds = implode(',', $cid);

            $query = 'UPDATE #__getmailing' . ' SET published = '.(int) $publish . ' WHERE id IN ( '.$listaIds.' )';

            $this->_db->setQuery( $query );

            if (!$this->_db->query()) {

                $this->setError($this->_db->getErrorMsg());

                return false;

            }

        }

        return true;

    }

}

?>